/*
LodePNG Examples

Copyright (c) 2005-2012 Lode Vandevenne

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
    claim that you wrote the original software. If you use this software
    in a product, an acknowledgment in the product documentation would be
    appreciated but is not required.

    2. Altered source versions must be plainly marked as such, and must not be
    misrepresented as being the original software.

    3. This notice may not be removed or altered from any source
    distribution.
*/

#include "C:\Users\Chris\source\repos\PNG\lodepng.h"
#include "C:\Users\Chris\source\repos\PNG\lodepng.cpp"
#include <Windows.h>
#include <algorithm>
#include <memory>


#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <atlstr.h>
#include <msclr/marshal_cppstd.h>

#include <iterator>

#define __STDC_WANT_LIB_EXT1__ 1
#include <string.h>
#include <stdio.h>

#include <iostream>
#include <bitset>
using namespace std;


//Encode from raw pixels to disk with a single function call
//The image argument has width * height RGBA pixels or width * height * 4 bytes
void encodeOneStep(const char* filename, std::vector<unsigned char>& image, unsigned width, unsigned height) {
    //Encode the image
    unsigned error = lodepng::encode(filename, image, width, height);

    //if there's an error, display it
    if (error) std::cout << "encoder error " << error << ": " << lodepng_error_text(error) << std::endl;
}



int main(int argc, char* argv[])
{
    const unsigned width = 16, height = 16, no_elems = width * height * 4;
    std::vector<unsigned char> image(no_elems);
    const char* filename = argc > 1 ? argv[1] : "test.png";

    //  Pallette
    static const unsigned char colours[16][4] = { // An array of colour values
        //BBB  GGG  RRR AA
        { 255, 255, 255,255 }, /* White    */
        {   64,  48,  0, 255 }, /* Index  1 */ // reversed
        {   112,  72, 0, 255 }, /* Index  2 */ // reversed
        {  168, 104, 56, 255 }, /* Index  3 */  // reversed
        {   216, 152, 0, 255 }, /* Index  4 */ // reversed
        {   248, 216, 8, 255 }, /* Index  5 */ // reversed 
        { 255, 255, 255 }, /* Index  6 */
        { 208, 208, 208 }, /* Index  7 */
        { 160, 160, 160 }, /* Index  8 */
        { 112, 120, 120 }, /* Index  9 */
        {   0,   0,  72 }, /* Index 10 */
        {   8,   8, 160 }, /* Index 11 */
        {  16,  16, 248 }, /* Index 12 */
        {   8, 104, 248 }, /* Index 13 */
        {   0, 248,   0 }, /* Index 14 */
        {   0,   0,   0 }  /* Index 15 */
    };

    char oData[0x2000]; // The Array
    ifstream inFile;
    inFile.open("C:\\Users\\Chris\\Desktop\\DK\\Emulators ad Debuggers\\zsnesw150\\dkc1.sfc");
    inFile.seekg(0xEF88E + 10, 1);
    inFile.read(oData, 0x2000);
    inFile.close();

    int E = 0;
    int F = 0;

    int* Bitplane0_Top_Left_ROW = new int[8];
    int* Bitplane1_Top_Left_ROW = new int[8];
    int* Bitplane2_Top_Left_ROW = new int[8];
    int* Bitplane3_Top_Left_ROW = new int[8];

    int* Bitplane0_Top_Right_ROW = new int[8];
    int* Bitplane1_Top_Right_ROW = new int[8];
    int* Bitplane2_Top_Right_ROW = new int[8];
    int* Bitplane3_Top_Right_ROW = new int[8];

    int* Bitplane0_Bottom_Left_ROW = new int[8];
    int* Bitplane1_Bottom_Left_ROW = new int[8];
    int* Bitplane2_Bottom_Left_ROW = new int[8];
    int* Bitplane3_Bottom_Left_ROW = new int[8];

    int* Bitplane0_Bottom_Right_ROW = new int[8];
    int* Bitplane1_Bottom_Right_ROW = new int[8];
    int* Bitplane2_Bottom_Right_ROW = new int[8];
    int* Bitplane3_Bottom_Right_ROW = new int[8];

    for (int X = 0; X <= 40; X++)

    {


        // Letter K -- Top Left Tile
        Bitplane0_Top_Left_ROW[0] = oData[14 + E];
        Bitplane0_Top_Left_ROW[1] = oData[12 + E];
        Bitplane0_Top_Left_ROW[2] = oData[10 + E];
        Bitplane0_Top_Left_ROW[3] = oData[8 + E];
        Bitplane0_Top_Left_ROW[4] = oData[6 + E];
        Bitplane0_Top_Left_ROW[5] = oData[4 + E];
        Bitplane0_Top_Left_ROW[6] = oData[2 + E];
        Bitplane0_Top_Left_ROW[7] = oData[0 + E];

        Bitplane1_Top_Left_ROW[0] = oData[15 + E];
        Bitplane1_Top_Left_ROW[1] = oData[13 + E];
        Bitplane1_Top_Left_ROW[2] = oData[11 + E];
        Bitplane1_Top_Left_ROW[3] = oData[9 + E];
        Bitplane1_Top_Left_ROW[4] = oData[7 + E];
        Bitplane1_Top_Left_ROW[5] = oData[5 + E];
        Bitplane1_Top_Left_ROW[6] = oData[3 + E];
        Bitplane1_Top_Left_ROW[7] = oData[1 + E];

        Bitplane2_Top_Left_ROW[0] = oData[30 + E];
        Bitplane2_Top_Left_ROW[1] = oData[28 + E];
        Bitplane2_Top_Left_ROW[2] = oData[26 + E];
        Bitplane2_Top_Left_ROW[3] = oData[24 + E];
        Bitplane2_Top_Left_ROW[4] = oData[22 + E];
        Bitplane2_Top_Left_ROW[5] = oData[20 + E];
        Bitplane2_Top_Left_ROW[6] = oData[18 + E];
        Bitplane2_Top_Left_ROW[7] = oData[16 + E];

        Bitplane3_Top_Left_ROW[0] = oData[31 + E];
        Bitplane3_Top_Left_ROW[1] = oData[29 + E];
        Bitplane3_Top_Left_ROW[2] = oData[27 + E];
        Bitplane3_Top_Left_ROW[3] = oData[25 + E];
        Bitplane3_Top_Left_ROW[4] = oData[23 + E];
        Bitplane3_Top_Left_ROW[5] = oData[21 + E];
        Bitplane3_Top_Left_ROW[6] = oData[19 + E];
        Bitplane3_Top_Left_ROW[7] = oData[17 + E];

        // Letter K -- Top Right Tile


        Bitplane0_Top_Right_ROW[0] = oData[46 + E];
        Bitplane0_Top_Right_ROW[1] = oData[44 + E];
        Bitplane0_Top_Right_ROW[2] = oData[42 + E];
        Bitplane0_Top_Right_ROW[3] = oData[40 + E];
        Bitplane0_Top_Right_ROW[4] = oData[38 + E];
        Bitplane0_Top_Right_ROW[5] = oData[36 + E];
        Bitplane0_Top_Right_ROW[6] = oData[34 + E];
        Bitplane0_Top_Right_ROW[7] = oData[32 + E];

        Bitplane1_Top_Right_ROW[0] = oData[47 + E];
        Bitplane1_Top_Right_ROW[1] = oData[45 + E];
        Bitplane1_Top_Right_ROW[2] = oData[43 + E];
        Bitplane1_Top_Right_ROW[3] = oData[41 + E];
        Bitplane1_Top_Right_ROW[4] = oData[39 + E];
        Bitplane1_Top_Right_ROW[5] = oData[37 + E];
        Bitplane1_Top_Right_ROW[6] = oData[35 + E];
        Bitplane1_Top_Right_ROW[7] = oData[33 + E];

        Bitplane2_Top_Right_ROW[0] = oData[62 + E];
        Bitplane2_Top_Right_ROW[1] = oData[60 + E];
        Bitplane2_Top_Right_ROW[2] = oData[58 + E];
        Bitplane2_Top_Right_ROW[3] = oData[56 + E];
        Bitplane2_Top_Right_ROW[4] = oData[54 + E];
        Bitplane2_Top_Right_ROW[5] = oData[52 + E];
        Bitplane2_Top_Right_ROW[6] = oData[50 + E];
        Bitplane2_Top_Right_ROW[7] = oData[48 + E];

        Bitplane3_Top_Right_ROW[0] = oData[63 + E];
        Bitplane3_Top_Right_ROW[1] = oData[61 + E];
        Bitplane3_Top_Right_ROW[2] = oData[59 + E];
        Bitplane3_Top_Right_ROW[3] = oData[57 + E];
        Bitplane3_Top_Right_ROW[4] = oData[55 + E];
        Bitplane3_Top_Right_ROW[5] = oData[53 + E];
        Bitplane3_Top_Right_ROW[6] = oData[51 + E];
        Bitplane3_Top_Right_ROW[7] = oData[49 + E];


        // Letter K -- Bottom Left Tile


        Bitplane0_Bottom_Left_ROW[0] = oData[78 + E];
        Bitplane0_Bottom_Left_ROW[1] = oData[76 + E];
        Bitplane0_Bottom_Left_ROW[2] = oData[74 + E];
        Bitplane0_Bottom_Left_ROW[3] = oData[72 + E];
        Bitplane0_Bottom_Left_ROW[4] = oData[70 + E];
        Bitplane0_Bottom_Left_ROW[5] = oData[68 + E];
        Bitplane0_Bottom_Left_ROW[6] = oData[66 + E];
        Bitplane0_Bottom_Left_ROW[7] = oData[64 + E];

        Bitplane1_Bottom_Left_ROW[0] = oData[79 + E];
        Bitplane1_Bottom_Left_ROW[1] = oData[77 + E];
        Bitplane1_Bottom_Left_ROW[2] = oData[75 + E];
        Bitplane1_Bottom_Left_ROW[3] = oData[73 + E];
        Bitplane1_Bottom_Left_ROW[4] = oData[71 + E];
        Bitplane1_Bottom_Left_ROW[5] = oData[69 + E];
        Bitplane1_Bottom_Left_ROW[6] = oData[67 + E];
        Bitplane1_Bottom_Left_ROW[7] = oData[65 + E];

        Bitplane2_Bottom_Left_ROW[0] = oData[94 + E];
        Bitplane2_Bottom_Left_ROW[1] = oData[92 + E];
        Bitplane2_Bottom_Left_ROW[2] = oData[90 + E];
        Bitplane2_Bottom_Left_ROW[3] = oData[88 + E];
        Bitplane2_Bottom_Left_ROW[4] = oData[86 + E];
        Bitplane2_Bottom_Left_ROW[5] = oData[84 + E];
        Bitplane2_Bottom_Left_ROW[6] = oData[82 + E];
        Bitplane2_Bottom_Left_ROW[7] = oData[80 + E];

        Bitplane3_Bottom_Left_ROW[0] = oData[95 + E];
        Bitplane3_Bottom_Left_ROW[1] = oData[93 + E];
        Bitplane3_Bottom_Left_ROW[2] = oData[91 + E];
        Bitplane3_Bottom_Left_ROW[3] = oData[89 + E];
        Bitplane3_Bottom_Left_ROW[4] = oData[87 + E];
        Bitplane3_Bottom_Left_ROW[5] = oData[85 + E];
        Bitplane3_Bottom_Left_ROW[6] = oData[83 + E];
        Bitplane3_Bottom_Left_ROW[7] = oData[81 + E];


        // Letter K -- Bottom Right Tile


        Bitplane0_Bottom_Right_ROW[0] = oData[110 + E];
        Bitplane0_Bottom_Right_ROW[1] = oData[108 + E];
        Bitplane0_Bottom_Right_ROW[2] = oData[106 + E];
        Bitplane0_Bottom_Right_ROW[3] = oData[104 + E];
        Bitplane0_Bottom_Right_ROW[4] = oData[102 + E];
        Bitplane0_Bottom_Right_ROW[5] = oData[100 + E];
        Bitplane0_Bottom_Right_ROW[6] = oData[98 + E];
        Bitplane0_Bottom_Right_ROW[7] = oData[96 + E];

        Bitplane1_Bottom_Right_ROW[0] = oData[111 + E];
        Bitplane1_Bottom_Right_ROW[1] = oData[109 + E];
        Bitplane1_Bottom_Right_ROW[2] = oData[107 + E];
        Bitplane1_Bottom_Right_ROW[3] = oData[105 + E];
        Bitplane1_Bottom_Right_ROW[4] = oData[103 + E];
        Bitplane1_Bottom_Right_ROW[5] = oData[101 + E];
        Bitplane1_Bottom_Right_ROW[6] = oData[99 + E];
        Bitplane1_Bottom_Right_ROW[7] = oData[97 + E];


        Bitplane2_Bottom_Right_ROW[0] = oData[126 + E];
        Bitplane2_Bottom_Right_ROW[1] = oData[124 + E];
        Bitplane2_Bottom_Right_ROW[2] = oData[122 + E];
        Bitplane2_Bottom_Right_ROW[3] = oData[120 + E];
        Bitplane2_Bottom_Right_ROW[4] = oData[118 + E];
        Bitplane2_Bottom_Right_ROW[5] = oData[116 + E];
        Bitplane2_Bottom_Right_ROW[6] = oData[114 + E];
        Bitplane2_Bottom_Right_ROW[7] = oData[112 + E];


        Bitplane3_Bottom_Right_ROW[0] = oData[127 + E];
        Bitplane3_Bottom_Right_ROW[1] = oData[125 + E];
        Bitplane3_Bottom_Right_ROW[2] = oData[123 + E];
        Bitplane3_Bottom_Right_ROW[3] = oData[121 + E];
        Bitplane3_Bottom_Right_ROW[4] = oData[119 + E];
        Bitplane3_Bottom_Right_ROW[5] = oData[117 + E];
        Bitplane3_Bottom_Right_ROW[6] = oData[115 + E];
        Bitplane3_Bottom_Right_ROW[7] = oData[113 + E];

          E = E + 128 + 10;
        
        int c = 0;
        
        for (int p = 0; p < 8; p++) // Bottom Left Tile
        {

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Bottom_Left_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Bottom_Left_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Bottom_Left_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Bottom_Left_ROW[p] >> N) & 1);
                unsigned long Index = bs.to_ulong();




                image[c++] = colours[Index][0]; // Red
                image[c++] = colours[Index][1]; // Green
                image[c++] = colours[Index][2]; // Blue 
                image[c++] = colours[Index][3]; // Alpha
            }

            if (p == 0) { c = 48; }
            if (p == 1) { c = 96; }
            if (p == 2) { c = 144; }
            if (p == 3) { c = 192; }
            if (p == 4) { c = 240; }
            if (p == 5) { c = 288; }
            if (p == 6) { c = 336; }

        }

        for (int p = 0; p < 8; p++) // Top Left Tile
        {
            if (p == 0) { c = 384; }
            if (p == 1) { c = 432; }
            if (p == 2) { c = 480; }
            if (p == 3) { c = 528; }
            if (p == 4) { c = 576; }
            if (p == 5) { c = 624; }
            if (p == 6) { c = 672; }
            if (p == 7) { c = 720; }

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Top_Left_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Top_Left_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Top_Left_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Top_Left_ROW[p] >> N) & 1);
                unsigned long Index = bs.to_ulong();

                image[c++] = colours[Index][0]; // Red
                image[c++] = colours[Index][1]; // Green
                image[c++] = colours[Index][2]; // Blue 
                image[c++] = colours[Index][3]; // Alpha

            }
        }
        for (int p = 0; p < 8; p++) // Bottom Right Tile.
        {
            if (p == 0) { c = 24; }
            if (p == 1) { c = 72; }
            if (p == 2) { c = 120; }
            if (p == 3) { c = 168; }
            if (p == 4) { c = 216; }
            if (p == 5) { c = 264; }
            if (p == 6) { c = 312; }
            if (p == 7) { c = 360; }

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Bottom_Right_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Bottom_Right_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Bottom_Right_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Bottom_Right_ROW[p] >> N) & 1);
                unsigned long Index = bs.to_ulong();

                image[c++] = colours[Index][0]; // Red
                image[c++] = colours[Index][1]; // Green
                image[c++] = colours[Index][2]; // Blue 
                image[c++] = colours[Index][3]; // Alpha

            }

        }
        for (int p = 0; p < 8; p++) // Top Right Tile.
        {
            if (p == 0) { c = 408; }
            if (p == 1) { c = 456; }
            if (p == 2) { c = 504; }
            if (p == 3) { c = 552; }
            if (p == 4) { c = 600; }
            if (p == 5) { c = 648; }
            if (p == 6) { c = 696; }
            if (p == 7) { c = 744; }

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Top_Right_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Top_Right_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Top_Right_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Top_Right_ROW[p] >> N) & 1);
                unsigned long Index = bs.to_ulong();

                image[c++] = colours[Index][0]; // Red
                image[c++] = colours[Index][1]; // Green
                image[c++] = colours[Index][2]; // Blue 
                image[c++] = colours[Index][3]; // Alpha

            }


        }


        if (X == 0)
        {
            encodeOneStep(filename, image, width, height);
        }
    }



    return 0;

}


